package loja;

import java.rmi.*;
import javax.ejb.*;
import javax.naming.*;
import java.util.*;

public class ProdutoSessionBean implements SessionBean {
	SessionContext ctx;
	public void ejbActivate() {}
	public void ejbPassivate() {}
	public void ejbRemove() {}
	public void setSessionContext(SessionContext ctx) {
		this.ctx = ctx;
	}
	public void ejbCreate() {}
	
	public String listarProdutos() {
		ProdutoLocalHome produtoHome = null;
		try {
			Context jndi = new InitialContext();
			produtoHome = (ProdutoLocalHome)jndi.lookup("java:comp/env/produto");
		} catch (NamingException e) {
			throw new EJBException ("" + e);
		}
		Collection produtos = null;
		try {
			produtos = produtoHome.findAllProdutos();
		} catch (FinderException e) {
			throw new EJBException ("" + e);
		}
		Iterator it = produtos.iterator();
		StringBuffer buffer = new StringBuffer();
		while(it.hasNext()) {
			ProdutoLocal produto = (ProdutoLocal)it.next();
			buffer.append(produto.getNome() + ", R$" + 
			              produto.getPreco() + ". Qte: " + 
						  produto.getQuantidade() + "\n");
		}
		return buffer.toString();
	}
	
	public void criarProduto(String nome, double preco, int quantidade) {
		ProdutoLocalHome produtoHome = null;
		try {
			Context jndi = new InitialContext();
			produtoHome = (ProdutoLocalHome)jndi.lookup("java:comp/env/produto");
		} catch (NamingException e) {
			throw new EJBException ("" + e);
		}
		try {
			String codigo = produtoHome.getProximoCodigo();
			produtoHome.create(codigo, nome, preco, quantidade);
		} catch (CreateException e) {
			throw new EJBException ("" + e);
		}
	}
}
