package loja.ejb;

import loja.integration.*;
import loja.*;

import javax.ejb.*;
import javax.jms.*;
import java.math.BigDecimal;
import java.util.*;

public class SessionFacadeBean implements SessionBean {
	private CompraLocalHome compraHome;
	private ItemLocalHome itemHome;
	private ProdutoLocalHome produtoHome;
	private CompraLocal compra;
	private SessionContext ctx;
	
	public void ejbActivate() {}
	public void ejbPassivate() {}
	public void ejbRemove() {}
	public void setSessionContext(SessionContext ctx) {
		this.ctx = ctx;
	}

	public void ejbCreate() throws CreateException {
		System.out.println("LojaSessionFacadeBean: ejbCreate()");
		try {
			ServiceLocator locator = ServiceLocator.getInstance();
			produtoHome = (ProdutoLocalHome) locator.findLocalEJB("ejb/loja/produto");
		} catch (LojaException e) {
			throw new CreateException("Service Locator failure: " + e);
		}
	}
	
	public void criarProduto(String nome, double preco, int qte) throws LojaException {
		try {
			produtoHome.create(produtoHome.getProximoCodigo(), nome, preco, qte);
		} catch (CreateException e) {
			throw new LojaException("" + e);
		}
	}
	
	public ProdutoVO[] listarProdutosDisponiveis() throws LojaException {
		try {
			Collection beans = produtoHome.findAll();
			System.out.println("listarProdutos():Achados " + beans.size() + " beans.");
			Iterator it = beans.iterator();
			List produtos = new ArrayList();
			while(it.hasNext()) {
				ProdutoLocal produtoBean = (ProdutoLocal) it.next();
				int quantidade = produtoBean.getQuantidade();
				if (quantidade > 0) {
					ProdutoVO produtoVO = new ProdutoVO();
					produtoVO.setCodigo(produtoBean.getCodigo());
					produtoVO.setNome(produtoBean.getNome());
					produtoVO.setPreco(produtoBean.getPreco());
					produtoVO.setQuantidade(quantidade);
					produtos.add(produtoVO);
				}
			}
			ProdutoVO[] buffer = new ProdutoVO[produtos.size()];
			return (ProdutoVO[]) produtos.toArray(buffer);
		} catch (FinderException e) {
			throw new LojaException(e);
		}
	}

}
